#!/bin/sh
set -e

# set JAVA_HOME from jpackage-utils if available
if [ ! -f @javadir@-utils/java-functions ]; then
	echo >&2 "jpackage-utils not found."
	exit 1
fi
. @javadir@-utils/java-functions

SCDIR=@scdir@
LIBPATH=$SCDIR/lib

MAIN_CLASS=net.java.sip.communicator.launcher.SIPCommunicator

cd "$SCDIR"

for jar in lib/*.jar; do
	CLASSPATH=$CLASSPATH:$jar
done
for jar in sc-launcher.jar util.jar; do
	CLASSPATH=$CLASSPATH:sc-bundles/$jar
done

FELIX_CONFIG=$LIBPATH/felix.client.run.properties
LOG_CONFIG=$LIBPATH/logging.properties


# set add LIBPATH to LD_LIBRARY_PATH for any sc natives (e.g. jmf .so's)
export LD_LIBRARY_PATH="${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$LIBPATH:$LIBPATH/native"

# extra options
OPTIONS="\
	-Djna.library.path=$LIBPATH \
	-Djava.library.path=$LIBPATH/native \
	-Dfelix.config.properties=file:$FELIX_CONFIG \
	-Djava.util.logging.config.file=$LOG_CONFIG \
"

VERBOSE=1

run "$@"
